#if GTEST
#include <gtest/gtest.h>

#include <math.h>
#include <limits>

#include "Angle16.h"
#include "Angle8.h"

#define FLOAT_INFINITY std::numeric_limits<float>::infinity()

TEST(Angle8, Construct) {
  float angle = 0.0F;
  Angle8 a = Angle8(angle);
  float f = (float)a;
  EXPECT_FLOAT_EQ(f, angle);

  angle = -180.0F;
  a = Angle8(angle);
  f = (float)a;
  EXPECT_FLOAT_EQ(f, angle);
}

TEST(Angle8, Negate) {
  float angle = 0;
  Angle8 a = Angle8(angle);
  a = -a;
  float f = (float)a;
  EXPECT_FLOAT_EQ(f, angle);

  angle = 90.0F;
  a = Angle8(angle);
  a = -a;
  f = (float)a;
  EXPECT_FLOAT_EQ(f, -angle);
}

TEST(Angle8, Add) {
  Angle8 a = Angle8::Degrees(0.0F);
  Angle8 b = Angle8(0.0F);
  Angle8 r = a + b;
  EXPECT_FLOAT_EQ((float)r, 0);
}

TEST(Angle16, Construct) {
  Angle16 a = Angle16(0.0F);
  float f = (float)a;
  EXPECT_FLOAT_EQ(f, 0);
}

TEST(Angle16, Negate) {
  float angle = 0;
  Angle16 a = Angle16(angle);
  a = -a;
  float f = (float)a;
  EXPECT_FLOAT_EQ(f, angle);

  angle = 90.0F;
  a = Angle16(angle);
  a = -a;
  f = (float)a;
  EXPECT_FLOAT_EQ(f, -angle);
}
#endif